<h1>IRC-server</h1>

> В далеком 1998 году, в сети DALnet, на одном популярном тогда русскоязычном канале, на вопрос новичка «А что такое IRC?», один человек ответил именно так:
*«IRC — это мания, это страх, это тоска, это желание, это первая программа, запускаемая на компьютере. IRC — это бессоные ночи, это несделанная работа, это отсутствие всякого образования, кроме умения стучать по клавишам!»‎*

IRC (Internet Relay Chat) – устаревший протокол прикладного уровня для обмена сообщениями в режиме реального времени. Разработан в 1988 году и предназначен для группового общения, также позволяет общаться через личные сообщения и обмениваться файлами. Несмотря на устарелость, на основе IRC в дальнейшем разработано множество мессенджеров, такие как: ICQ, Skype, Discord, Telegram, Slack, etc...

Проект представляет собой IRC-сервер, написанный на основе стандарта [rfc1459](https://datatracker.ietf.org/doc/html/rfc1459).
**ПРИМЕЧАНИЕ:** Cервер не поддерживает коммуникацию *сервер-сервер*.
Далее представлена сокращенная версия документации стандарта rfc1459 на русском языке.
<h4>Содержание:</h4>
[TOC]

---

## Сообщения

Каждое IRC-сообщение может содержать до трех частей, разделенных одним (или более) символом пробела: 

* Префикс (опционально)
* Команда
* Параметры команды(до 15).

**Префикс** используется серверами для обозначения источника появления сообщения. Обозначается одним символом `:`, стоящим вначале, который должен быть первым символом в сообщении. Между префиксом и `:` не должно быть никаких пробелов.

**Команда должна** содержать правильную IRC-команду или трехзначное число, представленное в ASCII-тексте. Максимальная длина строки для команд и параметров - 510 символов. Перенос строки невозможен.

Когда приходит ответ `ERR_NOSUCSERVER`, это значит, что параметр <server> не найден. Сервер может не отсылать других ответов после этой команды.
Сервер, к которому присоединился клиент требует к парсингу полное сообщение, возвращая любые найденные ошибки. Если сервер встретит смертельную ошибку в процессе парсинга, ошибка может быть возвращена обратно клиенту с остановкой процесса проверки. Эта ошибка может быть вызвана некорректной командой, направление которой неизвестно серверу (сервер, никнейм или название канала), не достаточно параметров или неправильные привилегии.

## Регистрация соединения

Рекомендуемые условия для регистрации клиента:

* PASS-сообщение
* NICK-сообщение
* USER-сообщение

#### PASS-сообщение

Команда PASS используется для установки 'парольного соединения'. Пароль может и должен быть установлен перед любой попыткой регистрации установленного соединения. В текущий момент, это требования к клиентам отправлять команду PASS перед отправкой комбинации NICK/USER.

Числовые ответы:

		ERR_NEEDMOREPARAMS		ERR_ALREADYREGISTRED

Пример:
```
  PASS secretpasswordhere
```

#### NICK-сообщение

Никнейм в данном случае выступает по смыслу как логин. Если сервер получит NICK, который уже существует, то произойдет конфликт и командой KILL удалит этот никнейм из базы данных сервера. Если сообщение NICK станет причиной изменения никнейма, то оргинальный (старый) никнейм удалится.
Числовые ответы:

		ERR_NONICKNAMEGIVEN		ERR_ERRONEUSNICKNAME
		ERR_NICKNAMEINUSE		ERR_NICKCOLLISION

Пример:
```
  NICK Wiz		// Вступление нового никнейма "Wiz".
  :WiZ NICK Kilroy	// WiZ изменяет свой никнейм на Kilroy.
```

#### USER-сообщение

**Параметры:** `<username>` `<hostname>` `<servername>` `<realname>`

Сообщение USER используется в начале соединения для указания имени пользователя, названия хоста, названия сервера и реального имени нового пользователя.

Должно быть обьявлено, что параметр `<realname>` должен быть последним, потому что он может содержать пробелы и перед ним должен быть префикс `:`, делающим распознавание более лучшим.

Числовые ответы:

		RR_NEEDMOREPARAMS		ERR_ALREADYREGISTRED

Пример:
```
  USER guest tolmoon tolsun :Ronnie Reagan
  // Пользователь зарегистрировал себя под именем "guest" и его реальное имя "Ronnie Reagan"
```

#### OPER

Сообщение OPER используется нормальным пользователем для взятия операторских прав. Параметры `<user>` и `<password>` используются для идентификации пользователя, запрашивающего права [IRC-оператора](####IRC-операторы).

Если клиент послал команду OPER с корректным паролем для текущего пользователя, сервер информамирует сеть о новом операторе, используя `MODE +o` для никнейма клиента.

Числовые ответы:

		ERR_NEEDMOREPARAMS		RPL_YOUREOPER
		ERR_NOOPERHOST			ERR_PASSWDMISMATCH

Пример:
```
  OPER foo bar
  // Попытка зарегистрироваться как IRC-оператор, используя имя пользователя "foo" и пароль "bar".
```

## Клиенты

Каждый клиент имеет никнейм длиной не больше девяти (9) символов. Доступные символы в нике: `a-z`, `A-Z`, `0-9`, `_`, `.`

Сервер должнен знать о клиенте:

* имя хоста, с которого запустился клиент.
* имя пользователя клиента на этом хосте.
* сервер, к которому присоединился клиент.

## Каналы

Канал создается при соединении первого клиента с ним и канал исчезает, когда его покидает последний клиент. Пока канал отсутствует, любой клиент может завладеть каналом, назвав свой таким же именем.
**Имя канала** – строка (начинающаяся с символа `&` или `#`) длинной до 200 символов.

Для создания нового канала или входа в существующий, пользователь должен запросить `JOIN` канала. Если канал отсутствовал, то канал создается и вошедший пользователь становится [оператором канала](####Channel-оператор). Если канал уже существует, но так или иначе он не отвечает на попытки войти, значит в настройках канала установлен какой-либо из нижеприведенных режимов. Возможно, этот канал только для приглашенных (invite-only), (режим +i), и вы сможете на его войти только будучи приглашенным. Пользователь может находится не нескольких каналах одновременно, но рекомендуется ограничиться десятью (10) каналами

#### JOIN

Команда `JOIN` используется клиентом для входа на канал. Для входа в канал, должны соблюдаться следующе условия:

1. Пользователь может быть приглашен, если канал invite-only.
2. Никнейм/имя пользователя/имя хоста не должны быть забанеными.
3. Если установлен пароль, но должен быть верным.

Когда пользователи заходят на канал, они получат уведомление о всех командах их сервера. Оно вмещает в себе `MODE`, `KICK`, `PART`, `QUIT` и, конечно же, `PRIVMSG`/`NOTICE`. Команда `JOIN` требуется для сообщения всем ерверам, чтобы каждый сервер знал, где искать пользователей, которые находятся на канале. Это позволяет оптимальную передачу сообщений `PRIVMSG`/`NOTICE` в канал.

Если `JOIN` выполнился успешно, пользователь получает топик канала(используя `RPL_TOPIC`) и список пользователей, которые находятся на канале (используя `RPL_NAMREPLY`).

Числовые ответы:

		ERR_NEEDMOREPARAMS		ERR_BANNEDFROMCHAN
		ERR_INVITEONLYCHAN		ERR_BADCHANNELKEY
		ERR_CHANNELISFULL		ERR_BADCHANMASK
		ERR_NOSUCHCHANNEL		ERR_TOOMANYCHANNELS
		RPL_TOPIC

Примеры:
```
  JOIN #foobar			// вход на канал #foobar.
  JOIN &foo fubar		// вход на канал &foo, используя ключ "fubar".
  JOIN #foo,&bar fubar		// вход на канал #foo, используя ключ "fubar" и на канал &bar без использования ключа.
  JOIN #foo,#bar fubar,foobar	// вход на канал #foo, используя ключ "fubar" и на канал #bar, используя ключ "foobar".
  JOIN #foo,#bar		// вход на каналы #foo и #bar.
  :WiZ JOIN #Twilight_zone	// JOIN-сообщение от WiZ
```

#### Channel-оператор

Владелец канала (оператор канала), идентифицируется символом `@`, следующим за его никнеймом, всякий раз, как он ассоциируется с каналом (например, ответы на команды NAMES, WHO и WHOIS)
Оператор канала имеет возможность выполнять команды:

* KICK
* INVITE (+i)
* TOPIC (+i)
* MODE

### IRC-операторы

IRC-операторы – специальный класс клиентов, имеющий возможность выполнять команды:

* RESTART (?)
* REHASH (?)
* KILL